/*
	Este programa nos leera una lista de la compra con SAX.
*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <cstdlib>
#include <iostream>
#include <qxml.h>
#include <qfile.h>
#include <qstring.h>

using namespace std;

class ClaseLista : public QXmlDefaultHandler //Esta es la clase que nos iran llamando cada vez que pase algo.
{
public:
	bool startDocument() { //el parser entro en el documento
		cout << "Tienes k comprar: " << endl;
		return true;
	}
	
	bool endDocument() { //el parser salio del documento
		return true;
	}
	
	bool endElement( const QString&, const QString&, const QString &name ) { //el parser salio de un elemento
		return true;
	}
	
	bool startElement( const QString&, const QString&, const QString &name, const QXmlAttributes &attrs ) { //el parser entro 
		if(name == "producto" ){ //si el elemento es un producto
			QString cant, tipo;
			for( int i=0; i<attrs.count(); i++ ) { //navegamos por los elementos
				if( attrs.localName( i ) == "cantidad" )
					cant = attrs.value( i );
				else if( attrs.localName( i ) == "tipo" )
					tipo = attrs.value( i );
			}
			
			cout << "\t- " << cant << " de " << tipo << endl;
		}
		
		return true;
	}
};

int main(int argc, char *argv[]){
	if(argc!=2){
		cout << "La sintaxis correcta es " << argv[0] << " <nombre del archivo>" << endl;
		exit(-1);
	}
	
	ClaseLista control; //declaramos la clase que hereda 
	QFile nuestralista(argv[1]); // inicializamos el archivo de ar en nuestralista
	QXmlInputSource documento(nuestralista);
	QXmlSimpleReader lector;
	
	lector.setContentHandler(&control);
	lector.parse(documento);
	return EXIT_SUCCESS;
}
