/***************************************************************************
 *   Copyright (C) 2005 by ,,,                                             *
 *   boooring@gmail.com                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "listagui.h"

ListaGui::ListaGui(QWidget *parent, const char *name) : QWidget(parent, name) {
	setMinimumSize( 250, 400 );
	
	QPopupMenu *file = new QPopupMenu( this );
	file->insertItem("&Abrir",  this, SLOT(obre()), CTRL+Key_A);
	file->insertItem("&Guardar", this, SLOT(guarda()), CTRL+Key_G);
	menu = new QMenuBar(this);
	menu->insertItem( "&Archivo", file );
	
	QPopupMenu *edit = new QPopupMenu( this );
	edit->insertItem("&Borra",  this, SLOT(esborra()), CTRL+Key_B);
	edit->insertItem("Aa&de", this, SLOT(afegeix()), CTRL+Key_D);
	edit->insertItem("Ed&ita", this, SLOT(edita()), CTRL+Key_I);
	menu->insertItem( "&Gestin", edit);
	
	llista = new QListView(this,"llista");
	llista->addColumn("Tipo");
	llista->addColumn("Cantidad");
}


ListaGui::~ListaGui(){}

bool ListaGui::escriu(){
	QDomDocument doc;
	QFile file(path);
	if ( !file.open( IO_ReadOnly ) )
		return false;
	if ( !doc.setContent( &file ) ) {
		file.close();
		return false;
	}
	file.close();
	QDomElement docElem = doc.documentElement(),e;
	QDomNode elem = docElem.firstChild(), i;
	QString tipo, cant;
	QListViewItem *item;
	while( !elem.isNull() ) { //recorremos todos los hijos de la raiz mediante un bucle
		e = elem.toElement();
		cant = e.attribute("cantidad");
		tipo = e.attribute("tipo");
		qDebug(cant + " de " + tipo); //saldr por consola tambin
		item = new QListViewItem(llista, tipo,cant);
		elem = elem.nextSibling();
	}
	return true;
}

void ListaGui::obre(){
	QString ar = QFileDialog::getOpenFileName("/home/", "Archivos XML (*.xml)", this, "Abrir", "Escoje un archivo");
	
	path = ar;
	
	if(!escriu())
		QMessageBox::warning(this, "Error en abrir el archivo", "Error: "+ ar, "Ok", ar,0,0,1);
}


void ListaGui::guarda(){
	QDomDocument doc("ListaDeLaCompraML");
	QDomElement root = doc.createElement( "lista" );
	QListViewItemIterator it(llista);
	doc.appendChild( root );
	QDomElement hijo;
	
	while ( it.current() ) {
		hijo = doc.createElement("producto");
		hijo.setAttribute("tipo", it.current()->text(0));
		hijo.setAttribute("cantidad",it.current()->text(1));
		root.appendChild(hijo);
		++it;
	}
	QFile file(path);
	QString output = doc.toString();
	if(file.open(IO_WriteOnly)){
		QTextStream stream(&file);
		stream << output;
		file.close();
	}
}

void ListaGui::esborra(){
	QListViewItem *p = llista->selectedItem();
	
	if(p != NULL && QMessageBox::warning(this,"Lista de la compra", "Est seguro que de quiere borrar " + p->text(0) + "?", "Cancelar", "Acepto")){
		llista->takeItem(p);
	}
}
void ListaGui::afegeix(){
	QString tipo = QInputDialog::getText("Tipo", "Qu tipo de producto necesitas?");
	if (tipo.isEmpty()) 
		return;
	QString cant = QInputDialog::getText("Cantidad", "Cuanto necesitas?");
	if (!tipo.isEmpty() ) 
		QListViewItem *p = new QListViewItem(llista,tipo, cant);
	
}

void ListaGui::edita(){
	bool ok;
	QListViewItem *p = llista->selectedItem();
	if(p==NULL)
		return;
	QString cant = QInputDialog::getText("Tipo", "Cuanto necesitas? [" + p->text(0) + "]", QLineEdit::Normal, p->text(1), &ok, this);
	if ( ok && !cant.isEmpty() ) {
		p->setText(1,cant);
	}
}

void ListaGui::resizeEvent(QResizeEvent* qre){
	QSize mida = qre->size();
	llista->setGeometry(0, 30, mida.width(), mida.height()-30);
}



